﻿Type=Class
Version=2.52
@EndOfDesignText@
'this class holds references to cHTabPanels
'will hold all tabs in one place, and hide/show them based on user wants
Sub Class_Globals
	
	'Views and Pointers
	Private asView As Panel 'for adding to the display
	Private listMyChildren As List 'for storing myChildren
	Private maxChildBMPWidth As Int 'to store their bitmap size
	
	Private vModule As Object
	Private vActivity As Activity
	Private imgBMP As ImageView 'to hold the bitmap if there
	Private bmpWidth As Int
	Private bmpHeight As Int
	Private lblText As Label
	
	Private bBMPDrawn As Boolean 'for startpanel reasons
	
	'Animations
	Private animspeed As Long
	Private tabAnimSpeed As Long
	Public animSpeed_Fast = 500
	Public animspeed_Med = 1000
	Public animspeed_Slow = 1500
	Private animPlusPanelIn As AnimationPlus
	Private animPlusPanelOut As AnimationPlus
	Private animPlusTabIn As AnimationPlus
	Private animPlusTabOut As AnimationPlus
	Private animPlusHideTab As AnimationPlus
	Private animPlusShowTab As AnimationPlus
	Private bHideFlag As Boolean

	
	'MyTab Information
	Private myTab As Panel	'will be the 'Tab' that gets clicked on to make it appear
	Private itabTop As Int
	Private itabBottom As Int
	Private itabWidth As Int
	Private iTabTextColor As Int
	Private iTabColor As Int
	Private strTabText As String
	Private bRightSide As Boolean
	Private strText As String
	Private bBMPDrawn As Boolean
	
	Private itabStyle As Int
	Public tabStyle_Square = 1
	Public tabStyle_Trapezoid = 2
	Public tabStyle_Round = 3
	
	Private AsViewColor As Int
	Private ShiftAmount As Int 'needed for animation
	'this was a buggy thing... could remove it, but haven't
	Private iStartViewPosition As Int
	
	'my want this for future, if want tabs to be behind panels
	Private iViewLeft As Int 'need this for animation stuff
	
	
End Sub

'if no picture send "" , if no tabText send "" (Pick one, if both sent, only pic will be displayed)
'if text is sent, if tabHeight > tabWidth then text displaye vertical, else horizontal
'tabPicture must be in File.DirAssests
'default tabStyle is trapezoid, tabColor is opaque, tabText is Black
'tabTop and tabBottom are where the tab should be displayed
'tabThickness is how thick the base should be from the edge of the device
'when adding AsView, make it's dimensions whatever you want, just ensure
'that it is where you want it to be heightwise, as that will be where it slides
'in and out.
'if OnRight set, then tab will be on right side of screen
Public Sub Initialize(callingActivity As Activity, callingModule As Object, tabPictureFileName As String, _
									tabText As String, tabTop As Int, tabBottom As Int, tabWidth As Int, OnRight As Boolean)

	itabStyle = tabStyle_Trapezoid
	vActivity = callingActivity
	vModule = callingModule
	iTabColor = Colors.ARGB(30, 255, 255, 255)
	iTabTextColor = Colors.Black
	itabWidth = tabWidth
	itabTop = tabTop
	itabBottom = tabBottom
	If tabPictureFileName <> "" Then
		If File.Exists(File.DirAssets, tabPictureFileName) Then
			Dim bp As BitmapPlus
			Dim bmpDimensions As Map
			File.Copy(File.DirAssets, tabPictureFileName, File.DirInternalCache, tabPictureFileName)
			Dim aString As String
			aString = File.DirAssets
			bmpDimensions = bp.GetImageDimensions(File.DirInternalCache & "/" & tabPictureFileName)
			Dim width, height As Int
			width = bmpDimensions.GetValueAt(1)
			height = bmpDimensions.GetValueAt(0)
			imgBMP.Initialize("myTab")
			
			bmpWidth = tabWidth - 2dip
			bmpHeight = height*(tabWidth-2dip)/width
			
			imgBMP.Bitmap = LoadBitmapSample(File.DirAssets, tabPictureFileName, bmpWidth, bmpHeight)
			imgBMP.Gravity = Gravity.FILL
		Else
			Msgbox("no picture loaded for TabPanel, no " & tabPictureFileName & " file exists", "No Pic")
		End If
	Else If tabText <> "" Then
		lblText.Initialize("myTab")
		lblText.Color = iTabColor
		lblText.TextColor = Colors.Black
		lblText.Text = tabText
		lblText.Typeface = Typeface.DEFAULT
		strText = tabText
	Else
		Msgbox("No text or picture sent to a cHTabPanel during initialization", "No Text or Pic")
	End If
	

	animspeed = animSpeed_Fast
	tabAnimSpeed = animSpeed_Fast
	bRightSide = OnRight
	iStartViewPosition = 0
	AsViewColor = Colors.Transparent
	listMyChildren.Initialize
End Sub


'sets the tab color
Public Sub setTabColor(newColor As Int)
	iTabColor = newColor
	If myTab.IsInitialized Then
		myTab.Color = newColor
	End If
End Sub

'sets the tab TextColor
Public Sub setTabTextColor(newColor As Int)
	iTabTextColor = newColor
	If lblText.IsInitialized Then
		lblText.TextColor = newColor
	End If
End Sub

'programatically open the panel
Public Sub OpenPanel(useAnimation As Boolean)
If animPlusPanelOut.IsInitialized Then
	animPlusPanelOut.Stop(asView)
	animPlusPanelIn.Stop(asView)
	animPlusTabOut.Stop(myTab)
	animPlusTabIn.Stop(myTab)
	vActivity.Invalidate
	DoEvents
End If
If useAnimation Then
	If bRightSide Then
		If asView.Left >= vActivity.Width Then
			myTab_Click
		End If
	Else
		If asView.Left+ asView.Width <= 0 Then
			myTab_Click
		End If
	End If
Else
	If bRightSide Then
		asView.Left = vActivity.Width - asView.Width
		myTab.Left = asView.Left - myTab.Width
	Else
		asView.Left = 0
		myTab.Left = asView.Width
	End If
End If
End Sub

'programatically close the panel
Public Sub ClosePanel(useAnimation As Boolean)

If animPlusPanelOut.IsInitialized Then
	animPlusPanelIn.Stop(asView)
	animPlusTabIn.Stop(myTab)
	DoEvents
	vActivity.Invalidate
End If

If useAnimation Then
	asView.Left = 0
	myTab.Left = 0
	ShiftAmount = asView.Top
	myTab.Top = myTab.Top - ShiftAmount
	asView.Top = 0
	
	asView.BringToFront
	myTab.BringToFront
	animPlusPanelIn.Start(asView)
	animPlusTabIn.Start(myTab)
	For Each child As cHTabPanel In listMyChildren
		child.HideTab(True)
	Next
Else
	If bRightSide Then
		asView.Left = vActivity.Width
		myTab.Left = asView.Left - myTab.Width
	Else
		asView.Left = - asView.Width
		myTab.Left = 0
	End If
End If		

End Sub


'programatically close the panel
Public Sub ClosePanel1(useAnimation As Boolean)
If animPlusPanelOut.IsInitialized Then
	animPlusPanelIn.Stop(asView)
	animPlusTabIn.Stop(myTab)
	DoEvents
	vActivity.Invalidate
End If

If useAnimation Then
	If bRightSide Then
		If asView.Left < vActivity.Width Then
			myTab_Click
		End If
	Else
		If asView.Left + asView.Width > 0 Then
			myTab_Click
		End If
	End If
Else
	If bRightSide Then
		asView.Left = vActivity.Width
		myTab.Left = asView.Left - myTab.Width
	Else
		asView.Left = - asView.Width
		myTab.Left = 0
	End If
End If

End Sub

'used to finalize and start the TabManager and TabChildren
'if PanelOpen set to True, then TabVisible will be ignored
Public Sub StartTabManager(PanelOpen As Boolean, TabVisible As Boolean)
'panel will be sent to its hiding spot
'and will copy over all children icons from same place as set

	
	
	If listMyChildren.Size = 0 Then
		Msgbox("Tab Manager Not Able To Start, no Child Tabs added", "Cannot Start")
	End If
	If Not(asView.IsInitialized) Then
		asView.Initialize("AsView")
		vActivity.AddView(asView, 0, 0, 10dip, 100%y) 'will change once all the children mytab's have been copied
	End If
	For Each child As cHTabPanel In listMyChildren
		child.StartTabPanel(PanelOpen)
	Next
	
	
	asView.RemoveAllViews
	asView.Color = AsViewColor
	FillChildrenSpecs
	asView.Width = maxChildBMPWidth
	setAnimationSpeed(animspeed) 'will do mine and childviews
	
	If Not(bBMPDrawn) Then
		myTab.Initialize("myTab")
		
		If PanelOpen Then
			If bRightSide Then
				vActivity.AddView(myTab, vActivity.Width - maxChildBMPWidth, itabTop, maxChildBMPWidth, itabBottom-itabTop)
			Else
				vActivity.AddView(myTab, 0, itabTop, maxChildBMPWidth, itabBottom-itabTop)
			End If
		Else
			If bRightSide Then
				vActivity.AddView(myTab, vActivity.Width, itabTop, maxChildBMPWidth, itabBottom-itabTop)
			Else
				vActivity.AddView(myTab, -maxChildBMPWidth, itabTop, maxChildBMPWidth, itabBottom-itabTop)
			End If
		End If
		
	End If
	
	
	
	If PanelOpen Then
		If bRightSide Then
			asView.Left = vActivity.Width - asView.Width
			myTab.Left = vActivity.Width - asView.Width - myTab.Width 
		Else
			asView.Left = 0
			myTab.Left = asView.Width
		End If
	Else
		If bRightSide Then
			asView.Left = vActivity.Width 
			myTab.Left = vActivity.Width - myTab.Width 
		Else
			asView.Left = -asView.Width
			myTab.Left = 0
		End If
		
	End If
		

	If imgBMP.IsInitialized AND Not(bBMPDrawn) Then
		myTab.AddView(imgBMP, 1dip, ((itabBottom-itabTop)-bmpHeight)/2, bmpWidth, bmpHeight)
		bBMPDrawn = True
	Else If Not(bBMPDrawn) Then
		'this means add a label
		
		If (itabBottom - itabTop) > itabWidth Then 'text goes vertical
			lblText.Text = convertToVertical(strText)
			'now fit it in
			If itabStyle = tabStyle_Round Then	
				myTab.AddView(lblText, 0, 0, myTab.Width, myTab.Height)
				Dim clip1 As Path
				If bRightSide Then
					clip1.Initialize(myTab.Width, 0)
					clip1.LineTo(myTab.Width, myTab.Height)
					clip1.LineTo(myTab.Width/2, myTab.Height)
					clip1.LineTo(myTab.Width/2, 0)
					clip1.LineTo(myTab.Width, 0)
				Else
					clip1.Initialize(0,0)
					clip1.LineTo(myTab.Width/2, 0)
					clip1.LineTo(myTab.Width/2, myTab.Height)
					clip1.LineTo(0, myTab.Height)
					clip1.LineTo(0, 0)
				End If
				Dim cv As Canvas
				cv.Initialize(myTab)
				cv.ClipPath(clip1)
				Dim rect1 As Rect
				rect1.Initialize(0, 0, myTab.Width, myTab.Height)
				cv.DrawRect(rect1, iTabColor, True, 1)
				cv.RemoveClip
				
				
				roundLabelCorner(lblText, iTabColor)
			Else If itabStyle = tabStyle_Trapezoid Then
				Dim bufferHeight As Float
				bufferHeight = .10 * myTab.Height
				myTab.AddView(lblText, 0, bufferHeight, myTab.Width, myTab.Height - bufferHeight*2)
				myTab.Color = Colors.Transparent
				
				Dim clip1 As Path
				If bRightSide Then
					clip1.Initialize(myTab.Width, 0)
					clip1.LineTo(myTab.Width, myTab.Height)
					clip1.LineTo(0, myTab.Height - bufferHeight)
					clip1.LineTo(0, bufferHeight)
					clip1.LineTo(myTab.Width, 0)
				Else
					clip1.Initialize(0,0)
					clip1.LineTo(myTab.Width, bufferHeight)
					clip1.LineTo(myTab.Width, myTab.Height - bufferHeight)
					clip1.LineTo(0, myTab.Height)
					clip1.LineTo(0,0)
				End If
				
				Dim cv As Canvas
				cv.Initialize(myTab)
				cv.ClipPath(clip1)
				
				Dim rect1 As Rect
				rect1.Initialize(0, 0, myTab.Width, myTab.Height)
				cv.DrawRect(rect1, iTabColor, True, 1)
				cv.RemoveClip
			Else 'this should be square!
				myTab.AddView(lblText, 0, 0, myTab.Width, myTab.Height)
				myTab.Color = iTabColor
			End If
			lblText.TextSize = setGrossFontSizeLabelMulti(lblText.Text, lblText.Typeface, lblText)
		
		Else 'text goes horizontal
			If itabStyle = tabStyle_Round Then
			
			
			Else If itabStyle = tabStyle_Trapezoid Then
				Dim bufferHeight As Float
				bufferHeight = .10 * myTab.Height
				myTab.AddView(lblText, 0, bufferHeight, myTab.Width, myTab.Height - bufferHeight*2)
				myTab.Color = Colors.Transparent
				
				Dim clip1 As Path
				If bRightSide Then
					clip1.Initialize(myTab.Width, 0)
					clip1.LineTo(myTab.Width, myTab.Height)
					clip1.LineTo(0, myTab.Height - bufferHeight)
					clip1.LineTo(0, bufferHeight)
					clip1.LineTo(myTab.Width, 0)
				Else
					clip1.Initialize(0,0)
					clip1.LineTo(myTab.Width, bufferHeight)
					clip1.LineTo(myTab.Width, myTab.Height - bufferHeight)
					clip1.LineTo(0, myTab.Height)
					clip1.LineTo(0,0)
				End If
				
				Dim cv As Canvas
				cv.Initialize(myTab)
				cv.ClipPath(clip1)
				
				Dim rect1 As Rect
				rect1.Initialize(0, 0, myTab.Width, myTab.Height)
				cv.DrawRect(rect1, iTabColor, True, 1)
				cv.RemoveClip
				
			Else 'this should be square!
				myTab.AddView(lblText, 0, 0, myTab.Width, myTab.Height)
				lblText.Color = iTabColor
				
			End If
			lblText.TextSize = setGrossFontSizeLabel(lblText.Text, lblText.Typeface, lblText)
		End If
		
		lblText.TextColor = iTabTextColor
		lblText.Gravity = Gravity.CENTER
		bBMPDrawn = True
	End If
	Dim ActivityWidth As Int
	ActivityWidth = vActivity.Width
	
	If bRightSide Then
		animPlusPanelIn.InitializeTranslate("animIn", ActivityWidth - asView.Width, asView.Top, vActivity.Width, asView.Top)
		animPlusPanelOut.InitializeTranslate("animOut", vActivity.Width , asView.Top, vActivity.Width - asView.Width, asView.Top)
		animPlusTabIn.InitializeTranslate("animTabIn", vActivity.Width - asView.Width - myTab.Width, asView.Top, vActivity.Width - myTab.Width, asView.Top)
		animPlusTabOut.InitializeTranslate("animTabOut", vActivity.Width - myTab.Width , asView.Top, vActivity.Width - asView.Width - myTab.Width, asView.Top)
		animPlusHideTab.InitializeTranslate("animHideTab", ActivityWidth - myTab.Width, itabTop, ActivityWidth, itabTop)
		animPlusShowTab.InitializeTranslate("animShowTab", ActivityWidth, itabTop, ActivityWidth - myTab.Width, itabTop)
	Else
		animPlusPanelIn.InitializeTranslate("animIn", 0, asView.Top, -asView.Width, asView.Top)
		animPlusPanelOut.InitializeTranslate("animOut", -asView.Width, asView.Top, 0, asView.Top)
		animPlusTabIn.InitializeTranslate("animTabIn", asView.Width, asView.Top, 0, asView.Top)
		animPlusTabOut.InitializeTranslate("animTabOut", 0, asView.Top, asView.Width, asView.Top)
		animPlusHideTab.InitializeTranslate("animHideTab", 0, myTab.Top, -myTab.Width, myTab.Top)
		animPlusShowTab.InitializeTranslate("animShowTab", -myTab.Width, myTab.Top, 0, myTab.Top)
	End If
	
	animPlusPanelIn.Duration = animspeed
	animPlusPanelOut.Duration = animspeed	
	animPlusTabIn.Duration = animspeed
	animPlusTabOut.Duration = animspeed
	animPlusShowTab.Duration = tabAnimSpeed
	animPlusHideTab.Duration = tabAnimSpeed
	asView.BringToFront
	myTab.BringToFront
	If Not(TabVisible) AND Not(PanelOpen) Then
		HideTab(False)
	End If
'	Catch
'		Msgbox("It appears that the AsView for an HTabPanel isn't loaded", "Not Loaded")
'	End Try


End Sub

'set the background color for the panel
Public Sub setPanelColor(newColor As Int)
	AsViewColor = newColor
	If asView.IsInitialized Then
		asView.Color = newColor
	End If
End Sub

Private Sub myTab_Click
	If CheckIfOpen Then
''		asView.Left = 0
''		myTab.Left = 0
''		ShiftAmount = asView.Top
''		myTab.Top = myTab.Top - ShiftAmount
''		asView.Top = 0
''		
''		asView.BringToFront
''		myTab.BringToFront
''		vActivity.Invalidate
''		animPlusPanelIn.Start(asView)
''		animPlusTabIn.Start(myTab)
''		For Each child As cHTabPanel In listMyChildren
''			child.HideTab(True)
''		Next
		ClosePanel(True)
	Else
		asView.Left = 0
		myTab.Left = 0
		ShiftAmount = asView.Top
		myTab.Top = myTab.Top - ShiftAmount
		asView.Top = 0
		asView.BringToFront
		myTab.BringToFront
		vActivity.Invalidate
		animPlusPanelOut.Start(asView)
		animPlusTabOut.Start(myTab)
		For Each child As cHTabPanel In listMyChildren
			child.ShowTab(True)
		Next
	End If
	
	
End Sub


'use to set animation speed
Public Sub setAnimationSpeed(newTime As Long)
If animPlusPanelIn.IsInitialized Then
	animPlusPanelIn.Duration = newTime
End If
animspeed = newTime

For Each child As cHTabPanel In listMyChildren
	child.setAnimationShowHideTabSpeed(animspeed)
Next

End Sub

'use to set the Tab hide/show speed 
'for just the Tab, Tab is connected to Panel when showing/hiding
Public Sub setAnimationShowHideTabSpeed(newTime As Long)
	If animPlusShowTab.IsInitialized Then
		animPlusShowTab.Duration = newTime
		animPlusHideTab.Duration = newTime
	End If
	tabAnimSpeed = newTime
End Sub


Private Sub animOut_AnimationEnd

If bRightSide Then
	asView.Left = vActivity.Width - asView.Width
	myTab.Left = asView.Left - myTab.Width
Else
	asView.Left = vActivity.Left
	myTab.Left = asView.Width
End If

End Sub

Private Sub animIn_AnimationEnd

asView.Left = vActivity.Width
If bRightSide Then
	asView.Left = vActivity.Left + vActivity.Width
	myTab.Left = vActivity.width - myTab.Width
Else
	asView.Left = vActivity.Left - asView.Width
	myTab.Left = vActivity.Left
End If

If bHideFlag Then
	animPlusPanelOut.Stop(asView)
	animPlusPanelIn.Stop(asView)
	animPlusTabOut.Stop(myTab)
	animPlusTabIn.Stop(myTab)
	vActivity.Invalidate
	myTab.Left = 0
	ShiftAmount = 0
	myTab.Top = 0
	myTab.BringToFront
	vActivity.Invalidate
	animPlusHideTab.Start(myTab)
	bHideFlag = False
End If
End Sub

Private Sub animTabIn_AnimationEnd
	If bRightSide Then
		myTab.Left = vActivity.Width - myTab.Width
	Else
		myTab.Left = -asView.Width - myTab.Width
	End If
	myTab.Top = myTab.Top + ShiftAmount
End Sub

Private Sub animTabOut_AnimationEnd
	If bRightSide Then
		myTab.Left = asView.Left - myTab.Width
	Else
		myTab.Left = vActivity.Left + asView.Width
	End If
	myTab.Top = myTab.Top + ShiftAmount
End Sub

Private Sub animHideTab_AnimationEnd
	If bRightSide Then
		myTab.Left = vActivity.Width
	Else
		myTab.Left = -myTab.Width
	End If
	myTab.Top = itabTop
End Sub

Private Sub animShowTab_AnimationEnd
If bRightSide Then
		myTab.Left = vActivity.Width - myTab.Width
	Else
		myTab.Left = 0
	End If
	myTab.Top = itabTop
End Sub

Private Sub convertToVertical(aString As String) As String
	Dim newString As String

	For i = 0 To aString.Length-1
		newString = newString & aString.SubString2(i, i+1) & CRLF
	Next
	
	newString = newString.SubString2(0, newString.Length-1)
  	Return newString
End Sub

'set a new Font Style
Public Sub SetTabFont(newTypeface As Typeface)
If lblText.IsInitialized Then
	lblText.Typeface = newTypeface
End If
End Sub

'Round, Trapezoid, Square
Public Sub SetTabStyle(newStyle As Int)
If newStyle = tabStyle_Square OR newStyle = tabStyle_Trapezoid OR newStyle = tabStyle_Round Then
	itabStyle = newStyle
Else
	Msgbox("setting of tab style is invalid value, leaving at current", "Not valid")
End If
End Sub

'add a panel to the Manager
Public Sub AddHTabPanel(newPanel As cHTabPanel)
	listMyChildren.Add(newPanel)
	CallSub2(newPanel, "SetManager", Me)
End Sub

Public Sub FillChildrenSpecs
Dim maxWidth As Int

Dim childTab As Panel
For Each child As cHTabPanel In listMyChildren
	childTab = child.GetMyTab
	If childTab.IsInitialized Then
		If childTab.Width  > maxWidth Then
			maxWidth = childTab.Width
		End If
	End If
Next

maxChildBMPWidth = maxWidth



End Sub

Private Sub CheckIfOpen As Boolean
If animPlusPanelOut.IsInitialized Then
	animPlusPanelOut.Stop(asView)
	animPlusPanelIn.Stop(asView)
	animPlusTabOut.Stop(myTab)
	animPlusTabIn.Stop(myTab)
	vActivity.Invalidate
End If

	If bRightSide Then
		If asView.Left >= vActivity.Width Then
			Return False
		Else
			Return True
		End If
	Else
		If (asView.Left+asView.Width) <= vActivity.Left Then
			Return False
		Else
			Return True
		End If
	End If
End Sub

'used to close any other children when a child is opened or closed
Private Sub CloseOtherChildren(childOpening As cHTabPanel)
	For Each child As cHTabPanel In listMyChildren
		If child <> childOpening Then
			child.ClosePanel(True)
		End If
	Next
End Sub

'hides the Tab Part
Public Sub HideTab(UseAnimation As Boolean)
'as this is the manager, no matter what need to hide everything else

If Not(UseAnimation) Then
	For Each child As cHTabPanel In listMyChildren
		child.ClosePanel(False)
		child.HideTab(False)
	Next
	ClosePanel(False)
	If bRightSide Then
		myTab.Left = vActivity.Width
	Else
		myTab.Left = -myTab.Width
	End If
Else
	If CheckIfOpen Then
		For Each child As cHTabPanel In listMyChildren
			child.ClosePanel(False)
		Next
		ClosePanel(True)
		bHideFlag = True
	Else If CheckTabShown Then
		myTab.Left = 0
		ShiftAmount = 0
		myTab.Top = 0
		myTab.BringToFront
		vActivity.Invalidate
		animPlusHideTab.Start(myTab)
	End If
End If
	
Return


If Not(myTab.IsInitialized) Then Return
	If UseAnimation Then
		If Not(CheckIfOpen) Then
			If CheckTabShown Then 'if not, then it's already hidden
				myTab.Left = 0
				ShiftAmount = 0
				myTab.Top = 0
				myTab.BringToFront
				vActivity.Invalidate
				animPlusHideTab.Start(myTab)
			End If
		End If
	Else
		If Not(CheckIfOpen) Then
			If bRightSide Then
				myTab.Left = vActivity.Width
			Else
				myTab.Left = -myTab.Width
			End If
		End If
	End If
End Sub


'shows the Tab Part
Public Sub ShowTab(UseAnimation As Boolean)
If Not(myTab.IsInitialized) Then Return
	If UseAnimation Then
		If Not(CheckIfOpen) Then
			If Not(CheckTabShown) Then 'if true, then already visible
				myTab.Left = 0
				ShiftAmount = 0
				myTab.Top = 0
				myTab.BringToFront
				vActivity.Invalidate
				animPlusShowTab.Start(myTab)
			End If
		End If
	Else
		If Not(CheckIfOpen) Then
			If bRightSide Then
				myTab.Left = vActivity.Width - myTab.Width
			Else
				myTab.Left = 0
			End If
		End If
	End If
End Sub


Private Sub CheckTabShown As Boolean
	If bRightSide Then
		If myTab.Left  >= vActivity.Width Then
			Return False
		Else
			Return True
		End If
	Else
		If myTab.Left < = -myTab.Width Then
			Return False
		Else
			Return True
		End If
	End If 
End Sub

#Region Styling

Private Sub setGrossFontSizeLabelMulti(someText As String, desiredFont As Typeface, desiredLabel As Label) As Float
'this sub will go thru and pick out the smallest size font for the set of textArray to fit in a label of the same size
'this will then return the fontsize that works for all  in the array
'label has same array dimesions as cb

Dim smallestFontSize As Float
smallestFontSize = 0


Dim cv As Canvas
cv.Initialize(desiredLabel)

Dim counter As Int

Dim su As StringUtils

Dim dummyLabel As Label
dummyLabel.Initialize("")
vActivity.AddView(dummyLabel, 100%x, 0, desiredLabel.Width, desiredLabel.Height)

dummyLabel.Text = someText
dummyLabel.TextSize = 1



Dim someHeight As Float
someHeight = su.MeasureMultilineTextHeight(dummyLabel, someText)

Do While someHeight < desiredLabel.Height
	dummyLabel.TextSize = dummyLabel.TextSize * 1.05
	someHeight = su.MeasureMultilineTextHeight(dummyLabel, someText)
Loop

dummyLabel.RemoveView

Return dummyLabel.TextSize/1.05

End Sub

Private Sub setGrossFontSizeLabel(someText As String, desiredFont As Typeface, desiredLabel As Label) As Float
'this sub will go thru and pick out the smallest size font for the set of textArray to fit in a label of the same size
'this will then return the fontsize that works for all  in the array
'label has same array dimesions as cb

Dim smallestFontSize As Float
smallestFontSize = 0


Dim cv As Canvas
cv.Initialize(desiredLabel)

Dim counter As Int


If someText.Trim = Null OR someText.Length < 1 Then
	Return 1
Else
	'binary tree this sucker
	Dim LowSize As Float
	Dim HighSize As Float
	LowSize = 1
	HighSize = 2
	Do While cv.MeasureStringWidth(someText, desiredFont, HighSize ) < (desiredLabel.width) AND _
				cv.MeasureStringHeight(someText, desiredFont, HighSize ) < desiredLabel.Height
			
			LowSize = HighSize
			HighSize = HighSize +50
	Loop
	
	'now have high and low, do the binary sort
	
	Dim MidSize As Float
	MidSize = (LowSize + HighSize)/2
	
	Dim WidthResult As Float
	Dim HeightResult As Float
	
	WidthResult = cv.MeasureStringWidth(someText, desiredFont, MidSize )/(desiredLabel.width)
	HeightResult = cv.MeasureStringHeight(someText, desiredFont, HighSize )/ desiredLabel.Height
	Do While WidthResult >=1 OR HeightResult >=1 OR (WidthResult < .95 AND HeightResult < .95)
		If WidthResult >=1 OR HeightResult >=1 Then
			HighSize = MidSize
		Else
			LowSize = MidSize
		End If
		
		MidSize = (HighSize + LowSize)/2
		
		If LowSize/HighSize > .97 Then
			Dim sizeFontinLoop As Float 'holds the font as it goes thru
			sizeFontinLoop = 1
			Dim countIncrement As Float 'for counting in powers of 10
			countIncrement = 10
			Do While countIncrement > 1
				Do While cv.MeasureStringHeight(  "ฦื้พุเลือกเสียง", desiredFont, sizeFontinLoop ) < (desiredLabel.height)
					sizeFontinLoop = sizeFontinLoop + countIncrement
				'	Msgbox (sizeFontinLoop, "sizefontinloop")
				Loop
				sizeFontinLoop = sizeFontinLoop - countIncrement
				countIncrement = countIncrement * .1
				''Msgbox (countIncrement, "countincremet")
			Loop
			
			If smallestFontSize = 0 Then
				smallestFontSize = sizeFontinLoop
			Else
				If sizeFontinLoop < smallestFontSize Then
					smallestFontSize = sizeFontinLoop
				End If
			End If
			Return smallestFontSize * .8
		End If
		
		WidthResult = cv.MeasureStringWidth(someText, desiredFont, MidSize )/(desiredLabel.width)
		HeightResult = cv.MeasureStringHeight(someText, desiredFont, HighSize )/ desiredLabel.Height
	Loop
End If

	Return MidSize * .96
			

End Sub

Private Sub roundLabelCorner (label1 As Label, someColor As Int)

  
Dim cdNewColor As ColorDrawable 
'set the New Color



   cdNewColor.Initialize(someColor,10)  

' Define a color for Pressed state  
Dim cdColorPressed As ColorDrawable  
cdColorPressed.Initialize(someColor, 15) 
' Define a StateListDrawable 
Dim stdGreenColor As StateListDrawable 
stdGreenColor.Initialize 
Dim states(2) As Int 
states(0) = stdGreenColor.state_enabled 
states(1) = -stdGreenColor.state_pressed 
stdGreenColor.addState2(states, cdNewColor) 
Dim states(1) As Int 
states(0) = stdGreenColor.state_pressed 
stdGreenColor.addState2(states, cdColorPressed)  ' Set stdGreenColor to button background  
label1.Background = stdGreenColor
'also do the padding
Dim R As Reflector    
	 R.Target = label1    
	 'Set padding to minimum    
	 R.RunMethod4("setPadding", Array As Object(0, 1dip, 0, 0), _
	 	Array As String("java.lang.int", "java.lang.int", "java.lang.int", "java.lang.int"))

End Sub
#End Region

