﻿Type=Class
Version=2.52
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	'Views and Pointers
	Public AsView As Panel 'for adding to the display
	Private myManager As cHTabManager 'if set, manager will be where the "MyTab" goes
	
	Private vModule As Object
	Private vActivity As Activity
	Private imgBMP As ImageView 'to hold the bitmap if there
	Private bmpWidth As Int
	Private bmpHeight As Int
	Private lblText As Label
	
	Private bBMPDrawn As Boolean 'for startpanel reasons
	
	'Animations
	Private animspeed As Long
	Private tabAnimSpeed As Long
	Public animSpeed_Fast = 500
	Public animspeed_Med = 1000
	Public animspeed_Slow = 1500
	
	Private animPlusPanelIn As AnimationPlus
	Private animPlusPanelOut As AnimationPlus
	Private animPlusTabIn As AnimationPlus
	Private animPlusTabOut As AnimationPlus
	Private animPlusHideTab As AnimationPlus
	Private animPlusShowTab As AnimationPlus


	
	'MyTab Information
	Private myTab As Panel	'will be the 'Tab' that gets clicked on to make it appear
	Private itabTop As Int
	Private itabBottom As Int
	Private itabWidth As Int
	Private iTabTextColor As Int
	Private iTabColor As Int
	Private strTabText As String
	Private bRightSide As Boolean
	Private strText As String
	
	Private itabStyle As Int
	Public tabStyle_Square = 1
	Public tabStyle_Trapezoid = 2
	Public tabStyle_Round = 3
	
	Private ShiftAmount As Int 'needed for animation
	
	'this was a buggy thing... could remove it, but haven't
	Private iStartViewPosition As Int
	
	'my want this for future, if want tabs to be behind panels
	Private iViewLeft As Int 'need this for animation stuff
	
	
End Sub

'if no picture send "" , if no tabText send "" (Pick one, if both sent, only pic will be displayed)
'if text is sent, if tabHeight > tabWidth then text displaye vertical, else horizontal
'tabPicture must be in File.DirAssests
'default tabStyle is trapezoid, tabColor is opaque, tabText is Black
'tabTop and tabBottom are where the tab should be displayed
'tabThickness is how thick the base should be from the edge of the device
'when adding AsView, make it's dimensions whatever you want, just ensure
'that it is where you want it to be heightwise, as that will be where it slides
'in and out.
'if OnRight set, then tab will be on right side of screen
Public Sub Initialize(callingActivity As Activity, callingModule As Object, tabPictureFileName As String, _
									tabText As String, tabTop As Int, tabBottom As Int, tabWidth As Int, OnRight As Boolean)

	itabStyle = tabStyle_Trapezoid
	vActivity = callingActivity
	vModule = callingModule
	AsView.Initialize("AsView")
	iTabColor = Colors.ARGB(30, 255, 255, 255)
	iTabTextColor = Colors.Black
	itabWidth = tabWidth
	itabTop = tabTop
	itabBottom = tabBottom
	If tabPictureFileName <> "" Then
		If File.Exists(File.DirAssets, tabPictureFileName) Then
			Dim bp As BitmapPlus
			Dim bmpDimensions As Map
			File.Copy(File.DirAssets, tabPictureFileName, File.DirInternalCache, tabPictureFileName)
			Dim aString As String
			aString = File.DirAssets
			bmpDimensions = bp.GetImageDimensions(File.DirInternalCache & "/" & tabPictureFileName)
			Dim width, height As Int
			width = bmpDimensions.GetValueAt(1)
			height = bmpDimensions.GetValueAt(0)
			imgBMP.Initialize("myTab")
			
			bmpWidth = tabWidth - 2dip
			bmpHeight = height*(tabWidth-2dip)/width
			
			imgBMP.Bitmap = LoadBitmapSample(File.DirAssets, tabPictureFileName, bmpWidth, bmpHeight)
			imgBMP.Gravity = Gravity.FILL
		Else
			Msgbox("no picture loaded for TabPanel, no " & tabPictureFileName & " file exists", "No Pic")
		End If
	Else If tabText <> "" Then
		lblText.Initialize("myTab")
		lblText.Color = iTabColor
		lblText.TextColor = Colors.Black
		lblText.Text = tabText
		lblText.Typeface = Typeface.DEFAULT
		strText = tabText
	Else
		Msgbox("No text or picture sent to a cHTabPanel during initialization", "No Text or Pic")
	End If
	

	animspeed = animspeed_Med
	tabAnimSpeed = animSpeed_Fast
	bRightSide = OnRight
	iStartViewPosition = 0
	
End Sub


'sets the tab color
Public Sub setTabColor(newColor As Int)
	iTabColor = newColor
	If myTab.IsInitialized Then
		myTab.Color = newColor
	End If
End Sub

'sets the tab TextColor
Public Sub setTabTextColor(newColor As Int)
	iTabTextColor = newColor
	If lblText.IsInitialized Then
		lblText.TextColor = newColor
	End If
End Sub

'programatically open the panel
Public Sub OpenPanel(useAnimation As Boolean)
If animPlusPanelOut.IsInitialized Then
	animPlusPanelOut.Stop(AsView)
	animPlusPanelIn.Stop(AsView)
	animPlusTabOut.Stop(myTab)
	animPlusTabIn.Stop(myTab)
	vActivity.Invalidate
	DoEvents
End If
If useAnimation Then
	If bRightSide Then
		If AsView.Left >= vActivity.Width Then
			myTab_Click
		End If
	Else
		If AsView.Left+ AsView.Width <= 0 Then
			myTab_Click
		End If
	End If
Else
	If bRightSide Then
		AsView.Left = vActivity.Width - AsView.Width
		myTab.Left = AsView.Left - myTab.Width
	Else
		AsView.Left = 0
		myTab.Left = AsView.Width
	End If
End If
End Sub

'programatically close the panel
Public Sub ClosePanel(useAnimation As Boolean)
If animPlusPanelOut.IsInitialized Then
	animPlusPanelIn.Stop(AsView)
	animPlusTabIn.Stop(myTab)
	DoEvents
	vActivity.Invalidate
End If

If useAnimation Then
	If bRightSide Then
		If AsView.Left < vActivity.Width Then
			myTab_Click
		End If
	Else
		If AsView.Left + AsView.Width > 0 Then
			myTab_Click
		End If
	End If
Else
	If CheckTabShown Then
		If bRightSide Then
			AsView.Left = vActivity.Width
			myTab.Left = AsView.Left - myTab.Width
		Else
			AsView.Left = - AsView.Width
			myTab.Left = 0
		End If
	End If
End If

End Sub

'used to finalize and start the TabPanel
Public Sub StartTabPanel(TabVisible As Boolean)
'panel will be sent to its hiding spot
'mytab wil be created and any text or pic added

	Try

		If bRightSide Then
			AsView.Left = vActivity.Width
		Else
			AsView.Left = vActivity.Left - AsView.Width
		End If
		
		If Not(myTab.IsInitialized) Then
			myTab.Initialize("myTab")
		
			If bRightSide Then
				vActivity.AddView(myTab, vActivity.Width - itabWidth, itabTop, itabWidth, itabBottom - itabTop)
			Else
				vActivity.AddView(myTab, vActivity.Left, itabTop, itabWidth, itabBottom - itabTop)
			End If
		End If

		AsView.BringToFront
		

		If imgBMP.IsInitialized AND Not(bBMPDrawn) Then
			myTab.AddView(imgBMP, 1dip, ((itabBottom-itabTop)-bmpHeight)/2, bmpWidth, bmpHeight)
			bBMPDrawn = True
		Else If Not(bBMPDrawn) Then
			'this means add a label
			
			If (itabBottom - itabTop) > itabWidth Then 'text goes vertical
				lblText.Text = convertToVertical(strText)
				'now fit it in
				If itabStyle = tabStyle_Round Then	
					myTab.AddView(lblText, 0, 0, myTab.Width, myTab.Height)
					Dim clip1 As Path
					If bRightSide Then
						clip1.Initialize(myTab.Width, 0)
						clip1.LineTo(myTab.Width, myTab.Height)
						clip1.LineTo(myTab.Width/2, myTab.Height)
						clip1.LineTo(myTab.Width/2, 0)
						clip1.LineTo(myTab.Width, 0)
					Else
						clip1.Initialize(0,0)
						clip1.LineTo(myTab.Width/2, 0)
						clip1.LineTo(myTab.Width/2, myTab.Height)
						clip1.LineTo(0, myTab.Height)
						clip1.LineTo(0, 0)
					End If
					Dim cv As Canvas
					cv.Initialize(myTab)
					cv.ClipPath(clip1)
					Dim rect1 As Rect
					rect1.Initialize(0, 0, myTab.Width, myTab.Height)
					cv.DrawRect(rect1, iTabColor, True, 1)
					cv.RemoveClip
					
					
					roundLabelCorner(lblText, iTabColor)
				Else If itabStyle = tabStyle_Trapezoid Then
					Dim bufferHeight As Float
					bufferHeight = .10 * myTab.Height
					myTab.AddView(lblText, 0, bufferHeight, myTab.Width, myTab.Height - bufferHeight*2)
					myTab.Color = Colors.Transparent
					lblText.Color = Colors.Transparent
					Dim clip1 As Path
					If bRightSide Then
						clip1.Initialize(myTab.Width, 0)
						clip1.LineTo(myTab.Width, myTab.Height)
						clip1.LineTo(0, myTab.Height - bufferHeight)
						clip1.LineTo(0, bufferHeight)
						clip1.LineTo(myTab.Width, 0)
					Else
						clip1.Initialize(0,0)
						clip1.LineTo(myTab.Width, bufferHeight)
						clip1.LineTo(myTab.Width, myTab.Height - bufferHeight)
						clip1.LineTo(0, myTab.Height)
						clip1.LineTo(0,0)
					End If
					
					Dim cv As Canvas
					cv.Initialize(myTab)
					cv.ClipPath(clip1)
					
					Dim rect1 As Rect
					rect1.Initialize(0, 0, myTab.Width, myTab.Height)
					cv.DrawRect(rect1, iTabColor, True, 1)
					cv.RemoveClip
				Else 'this should be square!
					myTab.AddView(lblText, 0, 0, myTab.Width, myTab.Height)
					myTab.Color = iTabColor
				End If
				lblText.TextSize = setGrossFontSizeLabelMulti(lblText.Text, lblText.Typeface, lblText)
			
			Else 'text goes horizontal
				If itabStyle = tabStyle_Round Then
				
				
				Else If itabStyle = tabStyle_Trapezoid Then
					Dim bufferHeight As Float
					bufferHeight = .10 * myTab.Height
					myTab.AddView(lblText, 0, bufferHeight, myTab.Width, myTab.Height - bufferHeight*2)
					myTab.Color = Colors.Transparent
					
					Dim clip1 As Path
					If bRightSide Then
						clip1.Initialize(myTab.Width, 0)
						clip1.LineTo(myTab.Width, myTab.Height)
						clip1.LineTo(0, myTab.Height - bufferHeight)
						clip1.LineTo(0, bufferHeight)
						clip1.LineTo(myTab.Width, 0)
					Else
						clip1.Initialize(0,0)
						clip1.LineTo(myTab.Width, bufferHeight)
						clip1.LineTo(myTab.Width, myTab.Height - bufferHeight)
						clip1.LineTo(0, myTab.Height)
						clip1.LineTo(0,0)
					End If
					
					Dim cv As Canvas
					cv.Initialize(myTab)
					cv.ClipPath(clip1)
					
					Dim rect1 As Rect
					rect1.Initialize(0, 0, myTab.Width, myTab.Height)
					cv.DrawRect(rect1, iTabColor, True, 1)
					cv.RemoveClip
					
				Else 'this should be square!
					myTab.AddView(lblText, 0, 0, myTab.Width, myTab.Height)
					lblText.Color = iTabColor
					
				End If
				lblText.TextSize = setGrossFontSizeLabel(lblText.Text, lblText.Typeface, lblText)
			End If
			
			lblText.Gravity = Gravity.CENTER
			bBMPDrawn = True
		End If
		
		
		
		
		If myManager.IsInitialized Then
			'see if the view has been given to the manager
		End If
		
		Dim ActivityWidth As Int
		ActivityWidth = vActivity.Width
		
		If bRightSide Then
			animPlusPanelIn.InitializeTranslate("animIn", ActivityWidth - AsView.Width, AsView.Top, vActivity.Width, AsView.Top)
			animPlusPanelOut.InitializeTranslate("animOut", vActivity.Width , AsView.Top, vActivity.Width - AsView.Width, AsView.Top)
			animPlusTabIn.InitializeTranslate("animTabIn", vActivity.Width - AsView.Width - myTab.Width, AsView.Top, vActivity.Width - myTab.Width, AsView.Top)
			animPlusTabOut.InitializeTranslate("animTabOut", vActivity.Width - myTab.Width , AsView.Top, vActivity.Width - AsView.Width - myTab.Width, AsView.Top)
			animPlusHideTab.InitializeTranslate("animHideTab", ActivityWidth - myTab.Width, itabTop, ActivityWidth, itabTop)
			animPlusShowTab.InitializeTranslate("animShowTab", ActivityWidth, itabTop, ActivityWidth - myTab.Width, itabTop)
		Else
			animPlusPanelIn.InitializeTranslate("animIn", 0, AsView.Top, -AsView.Width, AsView.Top)
			animPlusPanelOut.InitializeTranslate("animOut", -AsView.Width, AsView.Top, 0, AsView.Top)
			animPlusTabIn.InitializeTranslate("animTabIn", AsView.Width, AsView.Top, 0, AsView.Top)
			animPlusTabOut.InitializeTranslate("animTabOut", 0, AsView.Top, AsView.Width, AsView.Top)
			animPlusHideTab.InitializeTranslate("animHideTab", 0, myTab.Top, -myTab.width, myTab.Top)
			animPlusShowTab.InitializeTranslate("animShowTab", -myTab.width, myTab.Top, 0, myTab.Top)
		End If
	
		animPlusPanelIn.Duration = animspeed
		animPlusPanelOut.Duration = animspeed	
		animPlusTabIn.Duration = animspeed
		animPlusTabOut.Duration = animspeed
		animPlusShowTab.Duration = tabAnimSpeed
		animPlusHideTab.Duration = tabAnimSpeed
		AsView.BringToFront
		myTab.BringToFront
		If Not(TabVisible) Then
			HideTab(False)
		End If
	Catch
		Msgbox("It appears that the AsView for an HTabPanel isn't loaded", "Not Loaded")
	End Try


End Sub


Private Sub myTab_Click

	If CheckIfOpen Then
		AsView.Left = 0
		myTab.Left = 0
		ShiftAmount = AsView.Top
		myTab.Top = myTab.Top - ShiftAmount
		AsView.Top = 0
		
		AsView.BringToFront
		myTab.BringToFront
		vActivity.Invalidate
		animPlusPanelIn.Start(AsView)
		animPlusTabIn.Start(myTab)
	Else
		AsView.Left = 0
		myTab.Left = 0
		ShiftAmount = AsView.Top
		myTab.Top = myTab.Top - ShiftAmount
		AsView.Top = 0
		AsView.BringToFront
		myTab.BringToFront
		vActivity.Invalidate
		animPlusPanelOut.Start(AsView)
		animPlusTabOut.Start(myTab)
	End If

End Sub

'hides the Tab Part
Public Sub HideTab(UseAnimation As Boolean)
'this means no matter what, hide my tab
If Not(myTab.IsInitialized) Then Return
If Not(UseAnimation) Then
	ClosePanel(False)
	If bRightSide Then
		myTab.Left = vActivity.Width
	Else
		myTab.Left = -myTab.Width
	End If
Else
	If CheckIfOpen Then
		ClosePanel(False)
	End If
	If CheckTabShown Then
		myTab.Left = 0
		myTab.Top = 0
		ShiftAmount = 0
		myTab.BringToFront
		vActivity.Invalidate
		animPlusHideTab.Start(myTab)
	End If
End If

Return

End Sub


'shows the Tab Part
Public Sub ShowTab(UseAnimation As Boolean)
If Not(myTab.IsInitialized) Then Return
	If UseAnimation Then
		If Not(CheckIfOpen) Then
			If Not(CheckTabShown) Then 'if true, then already visible
				myTab.Left = 0
				myTab.Top = 0
				ShiftAmount = 0
				myTab.BringToFront
				vActivity.Invalidate
				animPlusShowTab.Start(myTab)
			End If
		End If
	Else
		If Not(CheckIfOpen) Then
			If bRightSide Then
				myTab.Left = vActivity.Width - myTab.Width
			Else
				myTab.Left = 0
			End If
		End If
	End If
End Sub

'use to set panel hide/show animation speed
Public Sub setAnimationSpeed(newTime As Long)
If animPlusPanelIn.IsInitialized Then
	animPlusPanelIn.Duration = newTime
	animPlusPanelOut.Duration = newTime
End If
	animspeed = newTime
End Sub

'use to set the Tab hide/show speed 
'for just the Tab, Tab is connected to Panel when showing/hiding
Public Sub setAnimationShowHideTabSpeed(newTime As Long)
	If animPlusShowTab.IsInitialized Then
		animPlusShowTab.Duration = newTime
		animPlusHideTab.Duration = newTime
	End If
	tabAnimSpeed = newTime
End Sub



Private Sub animOut_AnimationEnd
If bRightSide Then
	AsView.Left = vActivity.Width - AsView.Width
	myTab.Left = AsView.Left - myTab.Width
Else
	AsView.Left = vActivity.Left
	myTab.Left = AsView.Width
End If
	AsView.Top = ShiftAmount
End Sub

Private Sub animIn_AnimationEnd

AsView.Left = vActivity.Width
If bRightSide Then
	AsView.Left = vActivity.Left + vActivity.Width
	myTab.Left = vActivity.width - myTab.Width
Else
	AsView.Left = vActivity.Left - AsView.Width
	myTab.Left = vActivity.Left
End If
AsView.Top = ShiftAmount
End Sub

Private Sub animTabIn_AnimationEnd
	If bRightSide Then
		myTab.Left = vActivity.Width - myTab.Width
	Else
		myTab.Left = -AsView.Width - myTab.Width
	End If
	myTab.Top = myTab.Top + ShiftAmount
End Sub

Private Sub animTabOut_AnimationEnd
	If bRightSide Then
		myTab.Left = AsView.Left - myTab.Width
	Else
		myTab.Left = vActivity.Left + AsView.Width
	End If
	myTab.Top = myTab.Top + ShiftAmount
End Sub

Private Sub animHideTab_AnimationEnd
	If bRightSide Then
		myTab.Left = vActivity.Width
	Else
		myTab.Left = -myTab.Width
	End If
	myTab.Top = itabTop
End Sub

Private Sub animShowTab_AnimationEnd
If bRightSide Then
		myTab.Left = vActivity.Width - myTab.Width
	Else
		myTab.Left = 0
	End If
	myTab.Top = itabTop
End Sub


Private Sub convertToVertical(aString As String) As String
	Dim newString As String

	For i = 0 To aString.Length-1
		newString = newString & aString.SubString2(i, i+1) & CRLF
	Next
	
	newString = newString.SubString2(0, newString.Length-1)
  	Return newString
End Sub

Sub SetTabFont(newTypeface As Typeface)
If lblText.IsInitialized Then
	lblText.Typeface = newTypeface
End If
End Sub

'Round, Trapezoid, Square
Sub SetTabStyle(newStyle As Int)
If newStyle = tabStyle_Square OR newStyle = tabStyle_Trapezoid OR newStyle = tabStyle_Round Then
	itabStyle = newStyle
Else
	Msgbox("setting of tab style is invalid value, leaving at current", "Not valid")
End If
End Sub

'Used by TabManager to get Specs for its initialization
'normally not used by user
Public Sub GetMyTab As View
	If myTab.IsInitialized Then
		Return myTab
	Else
		'return uninitilized panel for use by manager
		Dim noPanel As Panel
		Return noPanel
	End If
End Sub

Private Sub SetManager(aManager As cHTabManager)
	myManager = aManager
End Sub

Private Sub CheckIfOpen As Boolean
If animPlusPanelOut.IsInitialized Then
	animPlusPanelOut.Stop(AsView)
	animPlusPanelIn.Stop(AsView)
	animPlusTabOut.Stop(myTab)
	animPlusTabIn.Stop(myTab)
	vActivity.Invalidate
End If

	If bRightSide Then
		If AsView.Left >= vActivity.Width Then
			Return False
		Else
			Return True
		End If
	Else
		If (AsView.Left+AsView.Width) <= vActivity.Left Then
			Return False
		Else
			Return True
		End If
	End If
End Sub

Private Sub CheckTabShown As Boolean
	If bRightSide Then
		If myTab.Left  >= vActivity.Width Then
			Return False
		Else
			Return True
		End If
	Else
		If myTab.Left < = -myTab.Width Then
			Return False
		Else
			Return True
		End If
	End If 
End Sub

#Region  Styling

Private Sub setGrossFontSizeLabelMulti(someText As String, desiredFont As Typeface, desiredLabel As Label) As Float
'this sub will go thru and pick out the smallest size font for the set of textArray to fit in a label of the same size
'this will then return the fontsize that works for all  in the array
'label has same array dimesions as cb

Dim smallestFontSize As Float
smallestFontSize = 0


Dim cv As Canvas
cv.Initialize(desiredLabel)

Dim counter As Int

Dim su As StringUtils

Dim dummyLabel As Label
dummyLabel.Initialize("")
vActivity.AddView(dummyLabel, 100%x, 0, desiredLabel.Width, desiredLabel.Height)

dummyLabel.Text = someText
dummyLabel.TextSize = 1



Dim someHeight As Float
someHeight = su.MeasureMultilineTextHeight(dummyLabel, someText)

Do While someHeight < desiredLabel.Height
	dummyLabel.TextSize = dummyLabel.TextSize * 1.05
	someHeight = su.MeasureMultilineTextHeight(dummyLabel, someText)
Loop

dummyLabel.RemoveView

Return dummyLabel.TextSize/1.05

End Sub

Private Sub setGrossFontSizeLabel(someText As String, desiredFont As Typeface, desiredLabel As Label) As Float
'this sub will go thru and pick out the smallest size font for the set of textArray to fit in a label of the same size
'this will then return the fontsize that works for all  in the array
'label has same array dimesions as cb

Dim smallestFontSize As Float
smallestFontSize = 0


Dim cv As Canvas
cv.Initialize(desiredLabel)

Dim counter As Int


If someText.Trim = Null OR someText.Length < 1 Then
	Return 1
Else
	'binary tree this sucker
	Dim LowSize As Float
	Dim HighSize As Float
	LowSize = 1
	HighSize = 2
	Do While cv.MeasureStringWidth(someText, desiredFont, HighSize ) < (desiredLabel.width) AND _
				cv.MeasureStringHeight(someText, desiredFont, HighSize ) < desiredLabel.Height
			
			LowSize = HighSize
			HighSize = HighSize +50
	Loop
	
	'now have high and low, do the binary sort
	
	Dim MidSize As Float
	MidSize = (LowSize + HighSize)/2
	
	Dim WidthResult As Float
	Dim HeightResult As Float
	
	WidthResult = cv.MeasureStringWidth(someText, desiredFont, MidSize )/(desiredLabel.width)
	HeightResult = cv.MeasureStringHeight(someText, desiredFont, HighSize )/ desiredLabel.Height
	Do While WidthResult >=1 OR HeightResult >=1 OR (WidthResult < .95 AND HeightResult < .95)
		If WidthResult >=1 OR HeightResult >=1 Then
			HighSize = MidSize
		Else
			LowSize = MidSize
		End If
		
		MidSize = (HighSize + LowSize)/2
		
		If LowSize/HighSize > .97 Then
			Dim sizeFontinLoop As Float 'holds the font as it goes thru
			sizeFontinLoop = 1
			Dim countIncrement As Float 'for counting in powers of 10
			countIncrement = 10
			Do While countIncrement > 1
				Do While cv.MeasureStringHeight(  "ฦื้พุเลือกเสียง", desiredFont, sizeFontinLoop ) < (desiredLabel.height)
					sizeFontinLoop = sizeFontinLoop + countIncrement
				'	Msgbox (sizeFontinLoop, "sizefontinloop")
				Loop
				sizeFontinLoop = sizeFontinLoop - countIncrement
				countIncrement = countIncrement * .1
				''Msgbox (countIncrement, "countincremet")
			Loop
			
			If smallestFontSize = 0 Then
				smallestFontSize = sizeFontinLoop
			Else
				If sizeFontinLoop < smallestFontSize Then
					smallestFontSize = sizeFontinLoop
				End If
			End If
			Return smallestFontSize * .8
		End If
		
		WidthResult = cv.MeasureStringWidth(someText, desiredFont, MidSize )/(desiredLabel.width)
		HeightResult = cv.MeasureStringHeight(someText, desiredFont, HighSize )/ desiredLabel.Height
	Loop
End If

	Return MidSize * .96
			

End Sub

Private Sub roundLabelCorner (label1 As Label, someColor As Int)

  
Dim cdNewColor As ColorDrawable 
'set the New Color



   cdNewColor.Initialize(someColor,10)  

' Define a color for Pressed state  
Dim cdColorPressed As ColorDrawable  
cdColorPressed.Initialize(someColor, 15) 
' Define a StateListDrawable 
Dim stdGreenColor As StateListDrawable 
stdGreenColor.Initialize 
Dim states(2) As Int 
states(0) = stdGreenColor.state_enabled 
states(1) = -stdGreenColor.state_pressed 
stdGreenColor.addState2(states, cdNewColor) 
Dim states(1) As Int 
states(0) = stdGreenColor.state_pressed 
stdGreenColor.addState2(states, cdColorPressed)  ' Set stdGreenColor to button background  
label1.Background = stdGreenColor
'also do the padding
Dim R As Reflector    
	 R.Target = label1    
	 'Set padding to minimum    
	 R.RunMethod4("setPadding", Array As Object(0, 1dip, 0, 0), _
	 	Array As String("java.lang.int", "java.lang.int", "java.lang.int", "java.lang.int"))

End Sub

#End Region
